/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or
 * redistribute the software under the terms of the CeCILL license as
 * circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * As a counterpart to the access to the source code and rights to copy, modify
 * and redistribute granted by the license, users are provided only with a
 * limited warranty and the software's author, the holder of the economic
 * rights, and the successive licensors have only limited liability. In this
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally,
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.scolarix.serveur.components.modules;

import org.cocktail.scolarix.serveur.components.controleurs.CtrlDiplomes_01;
import org.cocktail.scolarix.serveur.exception.EtudiantException;
import org.cocktail.scolarix.serveur.interfaces.IEtudiant;
import org.cocktail.scolarix.serveur.metier.eos.EOLangue;
import org.cocktail.scolarix.serveur.metier.eos.EOScolFormationHabilitation;
import org.cocktail.scolarix.serveur.metier.eos.EOVWebInscriptionResultat;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOResponse;

// Generated by the WOLips Templateengine Plug-in at 27 fevr. 2008 10:26:22
public class Diplomes_Cadre_C_01 extends ModuleDossierAdministratif {
	public CtrlDiplomes_01 ctrl;
	private EOScolFormationHabilitation uneFormationEnvisageable;
	private EOScolFormationHabilitation uneAutreFormationEnvisageable;
	private EOScolFormationHabilitation uneAutreFormationEnvisageableSelection;
	private EOVWebInscriptionResultat uneFormationEnCours;
	private EOScolFormationHabilitation uneFormationEnvisagee;
	private EOLangue uneLangueVivante;

	public Diplomes_Cadre_C_01(WOContext context) {
		super(context);
		ctrl = new CtrlDiplomes_01(this, session().defaultEditingContext());
	}

	public WOComponent enregistrer() {
		super.enregistrer();
		return null;
	}

	public void validate() throws EtudiantException {
		IEtudiant etudiant = etudiant();
		if (etudiant == null) {
			throw new EtudiantException("Pas d'étudiant !!!");
		}
		etudiant.validateDiplomes();
	}

	/**
	 * @return the uneFormationEnvisageable
	 */
	public EOScolFormationHabilitation uneFormationEnvisageable() {
		return uneFormationEnvisageable;
	}

	/**
	 * @param uneFormationEnvisageable
	 *            the uneFormationEnvisageable to set
	 */
	public void setUneFormationEnvisageable(EOScolFormationHabilitation uneFormationEnvisageable) {
		this.uneFormationEnvisageable = uneFormationEnvisageable;
	}

	/**
	 * @return the uneAutreFormationEnvisageable
	 */
	public EOScolFormationHabilitation uneAutreFormationEnvisageable() {
		return uneAutreFormationEnvisageable;
	}

	/**
	 * @param uneAutreFormationEnvisageable
	 *            the uneAutreFormationEnvisageable to set
	 */
	public void setUneAutreFormationEnvisageable(EOScolFormationHabilitation uneAutreFormationEnvisageable) {
		this.uneAutreFormationEnvisageable = uneAutreFormationEnvisageable;
	}

	/**
	 * @return the uneAutreFormationEnvisageableSelection
	 */
	public EOScolFormationHabilitation uneAutreFormationEnvisageableSelection() {
		return uneAutreFormationEnvisageableSelection;
	}

	/**
	 * @param uneAutreFormationEnvisageableSelection
	 *            the uneAutreFormationEnvisageableSelection to set
	 */
	public void setUneAutreFormationEnvisageableSelection(EOScolFormationHabilitation uneAutreFormationEnvisageableSelection) {
		this.uneAutreFormationEnvisageableSelection = uneAutreFormationEnvisageableSelection;
	}

	/**
	 * @return the uneFormationEnCours
	 */
	public EOVWebInscriptionResultat uneFormationEnCours() {
		return uneFormationEnCours;
	}

	/**
	 * @param uneFormationEnCours
	 *            the uneFormationEnCours to set
	 */
	public void setUneFormationEnCours(EOVWebInscriptionResultat uneFormationEnCours) {
		this.uneFormationEnCours = uneFormationEnCours;
	}

	/**
	 * @return the uneFormationEnvisagee
	 */
	public EOScolFormationHabilitation uneFormationEnvisagee() {
		return uneFormationEnvisagee;
	}

	/**
	 * @param uneFormationEnvisagee
	 *            the uneFormationEnvisagee to set
	 */
	public void setUneFormationEnvisagee(EOScolFormationHabilitation uneFormationEnvisagee) {
		this.uneFormationEnvisagee = uneFormationEnvisagee;
	}

	public WOActionResults ajouterUneFormationEnvisageable() {
		WOResponse response = null;
		try {
			etudiant().addFormationEnvisagee(uneFormationEnvisageable(), null);
		}
		catch (EtudiantException e) {
			response = new WOResponse();
			response.setStatus(500);
			String messageErreur = e.getMessageFormatte();
			session().setObjectForKey(messageErreur, "MessageErreur");
		}
		return response;
	}

	public WOActionResults ajouterUneAutreFormationEnvisageable() {
		WOResponse response = null;
		try {
			etudiant().addFormationEnvisagee(uneAutreFormationEnvisageableSelection(), null);
		}
		catch (EtudiantException e) {
			response = new WOResponse();
			response.setStatus(500);
			String messageErreur = e.getMessageFormatte();
			session().setObjectForKey(messageErreur, "MessageErreur");
		}
		return response;
	}

	public WOActionResults supprimerUneFormationEnvisagee() {
		WOResponse response = null;
		try {
			etudiant().removeFormationEnvisagee(uneFormationEnvisagee());
		}
		catch (EtudiantException e) {
			response = new WOResponse();
			response.setStatus(500);
			String messageErreur = e.getMessageFormatte();
			session().setObjectForKey(messageErreur, "MessageErreur");
		}
		return response;
	}

	/**
	 * @return the uneLangueVivante
	 */
	public EOLangue uneLangueVivante() {
		return uneLangueVivante;
	}

	/**
	 * @param uneLangueVivante
	 *            the uneLangueVivante to set
	 */
	public void setUneLangueVivante(EOLangue uneLangueVivante) {
		this.uneLangueVivante = uneLangueVivante;
	}

	public String styleForTypeAction() {
		String styleForTypeAction = "background-color:";
		if (uneFormationEnvisageable.typeAction().equals(EOScolFormationHabilitation.TYPE_ACTION_PROGRESSION)) {
			styleForTypeAction += "#00FF00";
		}
		else
			if (uneFormationEnvisageable.typeAction().equals(EOScolFormationHabilitation.TYPE_ACTION_REDOUBLEMENT)) {
				styleForTypeAction += "#FF0000";
			}
			else {
				styleForTypeAction = "";
			}
		return styleForTypeAction;
	}

	public boolean isAjouterFormationEnvisageablePossible() {
		boolean isAjouterFormationEnvisageablePossible = false;

		if (!isModeConsultation() && uneFormationEnvisageable().isSelectionnable()) {
			isAjouterFormationEnvisageablePossible = true;
		}
		return isAjouterFormationEnvisageablePossible;
	}

	public boolean isSupprimerFormationEnvisageePossible() {
		boolean isSupprimerFormationEnvisageePossible = false;

		if (!isModeConsultation() && uneFormationEnvisagee().isSelectionnable()) {
			isSupprimerFormationEnvisageePossible = true;
		}
		return isSupprimerFormationEnvisageePossible;
	}

}